// 002 u_script_executer
// 14 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_script_executer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, IBDatabase, DB, IBSQL, Grids,
  DBGrids, IBCustomDataSet, IBQuery;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    IBSQL1: TIBSQL;
    PageControl2: TPageControl;
    display_: TTabSheet;
    Memo1: TMemo;
    original_: TTabSheet;
    original_memo_: TMemo;
    no_comment_: TTabSheet;
    no_comment_memo_: TMemo;
    trimmed_: TTabSheet;
    trimmed_request_memo_: TMemo;
    PageControl1: TPageControl;
    database_: TTabSheet;
    base_directory_listbox_: TDirectoryListBox;
    base_file_listbox_: TFileListBox;
    script_: TTabSheet;
    Panel5: TPanel;
    create_base_: TButton;
    Panel7: TPanel;
    analyze_script_: TButton;
    connect_database_: TButton;
    exec_: TCheckBox;
    execute_script_: TButton;
    script_directory_listbox_: TDirectoryListBox;
    script_file_listbox_: TFileListBox;
    database_name_edit_: TEdit;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    select_: TTabSheet;
    portal_documents_edit_: TEdit;
    select__: TButton;
    IBQuery1: TIBQuery;
    display_select_: TTabSheet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure script_file_listbox_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure script_directory_listbox_change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure create_base_Click(Sender: TObject);
    procedure analyze_script_Click(Sender: TObject);
    procedure execute_script_Click(Sender: TObject);
    procedure connect_database_Click(Sender: TObject);
    procedure base_directory_listbox_Change(Sender: TObject);
    procedure base_file_listbox_Click(Sender: TObject);
    procedure database_name_edit_Change(Sender: TObject);
    procedure select__Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir
        , u_c_ini_file
        , u_strings
        , u_ibx
        , u_c_ib_script
        ;

    {$R *.DFM}

    //.create_path ..\exe\log
    //.create_path ..\_data\mastapp
    //.create_path ..\_data\mastapp

    const k_initial_path= 'c:\prog\uti_del\shell\';
            k_file_name= 'e.ed';
            k_extension= '.*';

          // -- ini keys
          k_save_path= k_initial_path;
          k_save_name= k_file_name;

          k_load_base_path_ini_key=      'load_base_path';
          k_load_base_file_name_ini_key= 'load_base_file_name';
          k_load_script_path_ini_key=      'load_script_path';
          k_load_script_file_name_ini_key= 'load_script_file_name';

          k_root_path= '..\_data\portal\';
          k_database_path= k_root_path;
            k_database_name= 'ASP_NET_STAERTER_KIT.GDB';

          k_script_path= k_root_path+ 'scripts\';
            k_script_name= '1_portal_tables.txt';

    var g_script_path: String= k_initial_path;
        g_script_file_name: String= k_file_name;

        g_base_path: String= k_initial_path;
        g_base_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

    procedure handle_file(p_path, p_file_name: String);
      begin
        display(p_file_name);
      end; // handle_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_base_path:= f_initialize_parameter(k_load_base_path_ini_key, k_save_path);
          display(g_base_path);
          g_base_file_name:= f_initialize_parameter(k_load_base_file_name_ini_key, k_save_name);
          database_name_edit_.Text:= g_base_file_name;

          g_script_path:= f_initialize_parameter(k_load_script_path_ini_key, k_save_path);
          g_script_file_name:= f_initialize_parameter(k_load_script_file_name_ini_key, k_save_name);
        end;

        set_directory_listbox_directory(base_directory_listbox_, g_base_path);
        set_directory_listbox_directory(script_directory_listbox_, g_script_path);
        script_file_listbox_.Mask:= '*'+ k_extension;

        Caption:= g_base_path+ g_base_file_name;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- file handling

    procedure TForm1.base_directory_listbox_Change(Sender: TObject);
      begin
        with base_directory_listbox_ do
          g_base_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_base_path_ini_key, g_base_path);
      end; // base_directory_listbox_Change

    procedure TForm1.base_file_listbox_Click(Sender: TObject);
      begin
        with base_file_listbox_ do
          g_base_file_name:= Items[ItemIndex];
        g_c_ini_file.set_parameter(k_load_base_file_name_ini_key, g_base_file_name);

        display(g_base_path+ g_base_file_name);

        IbDatabase1.SqlDialect:= 3;
        u_ibx.initialize_ib_database(g_base_path+ g_base_file_name, 'SYSDBA', 'masterkey', Form1.IbDatabase1);

        display_ib_database_name_info(Form1.IbDatabase1);
        f_open_ib_database('open', Form1.IbDatabase1);

        database_name_edit_.Text:= g_base_file_name;
      end; // base_file_listbox_

    procedure TForm1.database_name_edit_Change(Sender: TObject);
      begin
        g_base_file_name:= database_name_edit_.Text;
        g_c_ini_file.set_parameter(k_load_base_file_name_ini_key, g_base_file_name);
      end; // database_name_edit_Change

    procedure TForm1.script_directory_listbox_change(Sender: TObject);
      begin
        with script_directory_listbox_ do
          g_script_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_script_path_ini_key, g_script_path);
      end; // DirectoryListBox1Change

    procedure TForm1.script_file_listbox_Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with script_file_listbox_ do
          g_script_file_name:= Items[ItemIndex];
        display(g_script_path+ ' '+ g_script_file_name);
        g_c_ini_file.set_parameter(k_load_script_file_name_ini_key, g_script_file_name);

        handle_file(g_script_path, g_script_file_name);

        original_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        display_line;
        display('finished');
      end; // FileListBox1Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure TForm1.create_base_Click(Sender: TObject);
      begin
        display('> create_database');

        with IbDatabase1, Params do
        begin
          Connected:= False;

          display('create '+ g_base_path);
          display('  '+ g_base_file_name);

          If FileExists(g_base_path+ g_base_file_name)
            Then begin
                display('Erase');
                f_erase(g_base_path+ g_base_file_name);
                // Exit;
              end;

          DatabaseName:= g_base_path+ g_base_file_name;
          SqlDialect:= 3;
          Clear;

          Add('USER "sysdba"');
          Add('PASSWORD "masterkey"');
          Add('PAGE_SIZE 4096');

          Try
            CreateDatabase;
            display('  ok_created');
          except
            on e: Exception do
              display_bug_stop('*** err '+ e.Message);
          end; // try
        end; // with IbDatabase1, Params
        display('< create_database');
      end; // create_base_Click

    procedure connect;
      begin
        with Form1, IbDatabase1 do
        begin
          DatabaseName:= g_base_path+ g_base_file_name;
          Open;
          if not IbTransaction1.Active
            then display_bug_stop('trans_2_not_active');
          if not IbDatabase1.Connected
            then display_bug_stop('db3_not_connected');
        end;
      end; // connect

    procedure TForm1.analyze_script_Click(Sender: TObject);
      var l_request: String;
      begin
        original_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        if not FileExists(g_script_path+ g_script_file_name)
          then display_bug_stop('not_found '+ g_script_path+ g_script_file_name);

        with c_ib_script.create_ib_script('ib_script',  g_script_path+ g_script_file_name) do
        begin
          if f_initialized
            then begin
(*
                // test_scanner;
                l_no_comment:= f_remove_comment;
                // save_string_to_file(l_no_comment
                no_comment_memo_.Text:= l_no_comment;

                m_c_result_list.SaveToFile(g_script_path+ '_resu.txt');
*)
                clear_display;
                initialize_scanner;
                
                repeat
                  l_request:= f_get_request;
                  if not (m_is_SET_TERM or m_is_COMMIT_WORK or m_is_SET_AUTODDL)
                    then begin
                        display(l_request);
                        display('=== '+ m_terminator);
                      end;
                until l_request= '';
              end
            else display_bug_stop('not_found '+ g_script_path+ g_script_file_name)  ;
        end; // with c_ib_script
      end; // analyze_script_Click

    procedure TForm1.connect_database_Click(Sender: TObject);
      begin
        display('> open_database '+ g_base_path+ g_base_file_name);

        initialize_ib_database(g_base_path+ g_base_file_name,
            'sysdba', 'masterkey', IbDatabase1);

        with IbDatabase1 do
        begin
          SqlDialect:= 3;

          f_open_ib_database('open', IbDatabase1);
        end;
        display('< open_database');
      end; // connect_database_Click

    procedure TForm1.execute_script_Click(Sender: TObject);
      var l_c_ib_database: tIbDatabase;

      procedure execute_request(p_request: String);
        begin
          try
            if l_c_ib_database.DefaultTransaction.InTransaction
              then l_c_ib_database.DefaultTransaction.Commit;

            l_c_ib_database.DefaultTransaction.StartTransaction;
            IbSql1.Sql.Text:= p_request;
            display('> req');
            display_strings(IbSql1.Sql);
            display('< req');

            // -- for stored procedures
            IbSql1.ParamCheck:= False;

            IbSql1.ExecQuery;
            l_c_ib_database.DefaultTransaction.Commit;
          except
            on e: Exception do
              begin
                display_bug_stop('*** pb_'+ e.Message);
              end;
          end
        end; // execute_request

      var l_request: String;
          l_trimmed_request: String;

      begin // execute_script_Click
        original_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        if not FileExists(g_script_path+ g_script_file_name)
          then display_bug_stop('not_found '+ g_script_path+ g_script_file_name);

        display('open_database');
        l_c_ib_database:= IbDatabase1;

        connect_database_Click(Nil);
        display('set_ibsql_db');

        IbSql1.Database:= l_c_ib_database;

        with c_ib_script.create_ib_script('ib_script',  g_script_path+ g_script_file_name) do
        begin
          if f_initialized
            then begin
                display('scan');
                initialize_scanner;

                repeat
                  l_request:= f_get_request;
                  if not (m_is_SET_TERM or m_is_COMMIT_WORK or m_is_SET_AUTODDL)
                    then begin
                        display('=== '+ m_terminator);

                        // l_request:= f_remove_all_quotes(l_request, '"');

                        // clear_display;
                        l_trimmed_request:= f_add_return_line_feed(l_request);
                        l_trimmed_request:= f_change_returns_in_spaces(l_trimmed_request);
                        l_trimmed_request:= Trim(f_remove_double_spaces(l_trimmed_request));
                        trimmed_request_memo_.Lines.Add(l_trimmed_request);

                        if exec_.Checked
                          then begin
                              if   (Pos('DIALECT', l_request)<= 0)

(*
                                 and
                                   (Pos('ALTER PROCEDURE "CUSTOMERADD"', l_request)<= 0)
                                 and
                                   (Pos('ALTER PROCEDURE "CUSTOMERALSOBOUGHT"', l_request)<= 0)
*)
                                 and
                                   (Trim(l_request)<> '')
                                then
                                  execute_request(l_request)
                            end
                          else display(l_request);
                      end;
                until l_request= '';
              end
            else display_bug_stop('not_found '+ g_script_path+ g_script_file_name)  ;
        end; // with c_ib_script
      end; // execute_script_Click

    procedure TForm1.select__Click(Sender: TObject);
      begin
        u_ibx.initialize_ib_database(g_base_path+ g_base_file_name, 'SYSDBA', 'masterkey', Form1.IbDatabase1);

        f_open_ib_database('open', Form1.IbDatabase1);
        with IbQuery1, SQL do
        begin
          Close;
          Clear;
          Add('SELECT * FROM '+ portal_documents_edit_.Text);
          Open;
          PageControl2.ActivePage:= display_select_;

        end; // with IbQuery1
      end; // select__Click

end.


